<?php

// =================== LANGUAGE SELECT ===========================

function get_client_prefered_languages($getSortedList = true, $acceptedLanguages = false)
{

    if (empty($acceptedLanguages))
        $acceptedLanguages = $_SERVER["HTTP_ACCEPT_LANGUAGE"];

        // regex inspired from @GabrielAnderson on http://stackoverflow.com/questions/6038236/http-accept-language
    preg_match_all('/([a-z]{1,8}(-[a-z]{1,8})*)\s*(;\s*q\s*=\s*(1|0\.[0-9]+))?/i', $acceptedLanguages, $lang_parse);
    $langs = $lang_parse[1];
    $ranks = $lang_parse[4];


        // (create an associative array 'language' => 'preference')
    $lang2pref = array();
    for($i=0; $i<count($langs); $i++)
        $lang2pref[$langs[$i]] = (float) (!empty($ranks[$i]) ? $ranks[$i] : 1);

        // (comparison function for uksort)
    $cmpLangs = function ($a, $b) use ($lang2pref) {
        if ($lang2pref[$a] > $lang2pref[$b])
            return -1;
        elseif ($lang2pref[$a] < $lang2pref[$b])
            return 1;
        elseif (strlen($a) > strlen($b))
            return -1;
        elseif (strlen($a) < strlen($b))
            return 1;
        else
            return 0;
    };

        // sort the languages by prefered language and by the most specific region
    uksort($lang2pref, $cmpLangs);

    if ($getSortedList)
        return $lang2pref;

        // return the first value's key
    reset($lang2pref);
    return key($lang2pref);
}



function get_best_language(){

    include_once '/usr/share/mmc/includes/modules.inc.php';
    include_once '/usr/share/mmc/includes/i18n.inc.php';
    $langDesc = getArrLocale();
    $languages = list_system_locales('/usr/share/mmc/modules/base/locale/');
    
    $pref_languages = array_keys(get_client_prefered_languages());
    
    foreach ($pref_languages as $ulang) {
       // Get best language
       $lang_1 = substr($ulang, 0, 2);
       $lang_2 = str_replace('-','_', $ulang);
       
       // If lang1 = en => LANG =  C
       if ($lang_1 == 'en')
           return 'C';
       else // We check other languages
           // Searching with xx_XX pattern
           if (in_array($lang_2, $languages))
               return $lang_2;
           else
               // Searching with xx pattern
               foreach ($languages as $lang)
                   if (substr($lang, 0, 2) == $lang_1)
                       return $lang;
    }
}


?>
