<?php

session_start();
 
require_once 'includes/functions.php';
require_once 'includes/localization.php';

// =======================================================
// Force reactivation
// =======================================================

if (isset($_GET['reactivate']))
   set_license_data('');

// =======================================================
// Already activated product
// =======================================================

if (get_license_data() != ''){
  include 'templates/already_activated.phtml';
  
  // Leaving
  return;
}

// =======================================================
// 1st page: No post data
// =======================================================

if (!$_POST){
  // No form data => WELCOME PAGE
  include 'templates/welcome.phtml';
  return;
}


// =======================================================
// Receive activation method
// =======================================================

if (isset($_POST['activation_method'])){
  
  if ($_POST['activation_method'] == 1)
    include 'templates/auth_form.phtml';
  else
    include 'templates/offline_activation.phtml';
}
  
// =======================================================
// Online method : Receiving auth data
// =======================================================

if (isset($_POST['username'], $_POST['password'])){
  
  $username = $_POST['username'];
  $password = $_POST['password'];
  
  // Try authentication
  $res = lserv_query($username, $password, 'auth/customer/', array(
      'name_licence' => 'pulse',
      'gui_product' => get_installation_uuid()
  ));
    
  
  if ($res->codereturn == 403){
    // Wrong credentials
    include 'templates/auth_form.phtml';
    return;
  }
  
  if ($res->codereturn != 0){
    include 'templates/server_error.phtml';
  }
  else{
    // Auth success => saving credential into session
    $_SESSION['username'] = $username;
    $_SESSION['password'] = $password;
    
    $available_licenses = $res->product;
    include 'templates/license_list.phtml';
  }
  
  
}

// =======================================================
// Offline mode: Receiving activation code
// =======================================================

if (isset($_POST['activation_code'])){
    
  $licence_data = set_license_data($_POST['activation_code']);
  
  if ($licence_data){
  
      // Run post activate actions
      post_activate_actions_full();

      // Include finish template page
      include 'templates/finish.phtml';
  }
  else{
    $wrong_activation_code = TRUE;
    include 'templates/offline_activation.phtml';
  }
  
  return;
}


// =======================================================
// Online mode: Receiving selected license
// =======================================================

if (isset($_POST['selected_license'])){
  
  $username = $_SESSION['username'];
  $password = $_SESSION['password'];
  
  // Generate support ssh keys couple
  generate_support_ssh_keys();
  
  // Try activation
  $data = array(
      'name_licence'=> 'pulse',
      'gui_product'=> get_installation_uuid(),
      'id' => $_POST['selected_license'],
      'keypublique' => get_license_public_key(),
      'keysshpublique' => get_support_ssh_public_key(),
  );

  $oem = get_oem_id();
  if ($oem) $data['oem'] = $oem;

  $res = lserv_query($username, $password, 'activate/licencing/', $data);
  
  // Write license file
  if ($res->codereturn == 0 && !empty($res->licence)){
    // Writing licence data into licence.dat file
    
    $licence_data = set_license_data($res->licence);   
    
    if ($licence_data){

      post_activate_actions();
    
      // Write source.list for accessing updates
      foreach ($licence_data as $license){
        if ($license['alias'] != 'pulse' || $license['custon_number'] <= 5) {
          continue;
        }
      
        // Run post activate actions
        post_activate_actions_full(); 
      }
    
      include 'templates/finish.phtml';
      // TODO: Delete license public key
    }
  }
  else{
    
    if ($res->error == 'UUID already exist' && get_license_data() != '')
      include 'templates/already_activated.phtml';
    
  }
  
}

?>
